Package ru.bitel.bgbilling.modules.voice.common.service

# Interface VoiceService

@MTOM(enabled=true, threshold=1024) public interface VoiceService
Веб-сервис для работы с модулем Voice.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `calculate(Date dateFrom, Date dateTo, Set<Integer> contractIds, long groupMask, String email, String comment)`
  `void`
  `deleteAllGeographicCode(int operatorId)`
  Удаление всех географических кодов из БД.
  `int`
  `deleteGeographicCode(List<Integer> codes)`
  Удаление геокода (-ов) из БД.
  `String`
  `getGeographicCodeTree(int operatorId)`
  Получение дерева географических кодов оператора.
  `String`
  `importGeographicCode(int operatorId, boolean addNew, boolean updateExist, String importContent)`
  Импортирование списка географических кодов в БД.
  `void`
  `setBalance(Date month, String email, Set<Integer> contractIds)`
  `int`
  `updateGeographicCode(VoiceGeographicCode code)`
  Добавление нового/обновление существующего географического кода с одновременным обновлением истории геокода.
  `int`
  `voiceDestinationDelete(List<Integer> idSet)`
  Удаление направления (-ий) по коду.
  `VoiceDestination`
  `voiceDestinationGet(int id)`
  Получение одного конкретного направления по его коду.
  `SearchResult<VoiceDestination>`
  `voiceDestinationList(int operator, String title, Page page)`
  Получение списка направлений с сортировкой по имени.
  `void`
  `voiceDestinationReplace(int sourceDestinationId, int targetDestinationId)`
  Замена одного направления другим в привязке географических кодов
  `List<IdTitle>`
  `voiceDestinationTitles(List<Integer> destIds)`
  `int`
  `voiceDestinationUpdate(VoiceDestination destination)`
  Добавление нового (изменение существующего) направления.
  `List<VoiceGeographicCode>`
  `voiceGeographicCodeByDestinationId(int destinationId)`
  `List<IdTitle>`
  `voiceGeographicCodeTitles(int operatorId)`
  `void`
  `voiceGeographicRangeDelete(List<Integer> ids)`
  `VoiceGeographicRange`
  `voiceGeographicRangeGet(int id)`
  `String`
  `voiceGeographicRangeImport(int operatorId, String importData, boolean addDestination)`
  `String`
  `voiceGeographicRangeList(int operatorId)`
  `List<VoiceGeographicRange>`
  `voiceGeographicRanges(List<Integer> rangeIds)`
  `List<VoiceGeographicRange>`
  `voiceGeographicRangeSearch(int operatorId, String txt)`
  `int`
  `voiceGeographicRangeUpdate(VoiceGeographicRange range)`

- ## Method Details

  - ### voiceDestinationList

    SearchResult<VoiceDestination> voiceDestinationList(int operator, String title, Page page) throws Exception
    Получение списка направлений с сортировкой по имени.
    Parameters:
      `operator` - код оператора
      `title` - название направления или его часть
      `page` - информация о странице
      `destinations` - список направлений, сериализованных в виде json
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### voiceDestinationTitles

    List<IdTitle> voiceDestinationTitles(List<Integer> destIds) throws Exception
    Throws:
      `Exception`

  - ### voiceDestinationGet

    VoiceDestination voiceDestinationGet(int id) throws Exception
    Получение одного конкретного направления по его коду.
    Parameters:
      `id` - код направления.
    Returns:
      направление.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### voiceDestinationUpdate

    int voiceDestinationUpdate(VoiceDestination destination) throws Exception
    Добавление нового (изменение существующего) направления. Решение о добавлении или изменении существующего принимается исходя из условия id > 0.
    Parameters:
      `destination` - направление
    Returns:
      код вставленной (обновленной) записи.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### voiceDestinationDelete

    int voiceDestinationDelete(List<Integer> idSet) throws Exception
    Удаление направления (-ий) по коду.
    Parameters:
      `idSet` - список кодов направлений, подлежащих удалению.
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### voiceDestinationReplace

    void voiceDestinationReplace(int sourceDestinationId, int targetDestinationId) throws Exception
    Замена одного направления другим в привязке географических кодов
    Parameters:
      `sourceDestinationId` -
      `targetDestinationId` -
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `Exception`

  - ### getGeographicCodeTree

    String getGeographicCodeTree(int operatorId) throws Exception
    Получение дерева географических кодов оператора.
    Parameters:
      `date` - дата, на которую необходимо получить дерево
      `codes` - список кодов в виде дерева, сериализованное в виде json
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### voiceGeographicCodeTitles

    List<IdTitle> voiceGeographicCodeTitles(int operatorId) throws Exception
    Throws:
      `Exception`

  - ### updateGeographicCode

    int updateGeographicCode(VoiceGeographicCode code) throws Exception
    Добавление нового/обновление существующего географического кода с одновременным обновлением истории геокода.
    Parameters:
      `code` - экземпляр географического кода.
    Returns:
      код вставленной/обновленой записи.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### deleteGeographicCode

    int deleteGeographicCode(List<Integer> codes) throws Exception
    Удаление геокода (-ов) из БД.
    Parameters:
      `codeId` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### importGeographicCode

    String importGeographicCode(int operatorId, boolean addNew, boolean updateExist, String importContent) throws Exception
    Импортирование списка географических кодов в БД.
    Parameters:
      `addNew` - флаг, добавлять ли новые геокоды при отсутствии
      `updateExist` - флаг, обновлять ли существующие
      `importContent` - импортируемое содержимое в виде списка строк, каждая из которых разделена на поля
      `period` - период, который выставится у всех геокодов. По умолчанию, если не задано, то с текущего момента и до бесконечности.
    Returns:
      строка, содержащая список строк, которые не были обработаны по тем или иным причинам. Эта строка отобразится в клиенте
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### deleteAllGeographicCode

    void deleteAllGeographicCode(int operatorId) throws Exception
    Удаление всех географических кодов из БД.
    Throws:
      `Exception`

  - ### voiceGeographicCodeByDestinationId

    List<VoiceGeographicCode> voiceGeographicCodeByDestinationId(int destinationId) throws Exception
    Throws:
      `Exception`

  - ### calculate

    void calculate(Date dateFrom, Date dateTo, Set<Integer> contractIds, long groupMask, String email, String comment) throws Exception
    Throws:
      `Exception`

  - ### setBalance

    void setBalance(Date month, String email, Set<Integer> contractIds) throws Exception
    Throws:
      `Exception`

  - ### voiceGeographicRangeList

    String voiceGeographicRangeList(int operatorId) throws Exception
    Throws:
      `Exception`

  - ### voiceGeographicRangeGet

    VoiceGeographicRange voiceGeographicRangeGet(int id) throws Exception
    Throws:
      `Exception`

  - ### voiceGeographicRangeUpdate

    int voiceGeographicRangeUpdate(VoiceGeographicRange range) throws Exception
    Throws:
      `Exception`

  - ### voiceGeographicRangeDelete

    void voiceGeographicRangeDelete(List<Integer> ids) throws Exception
    Throws:
      `Exception`

  - ### voiceGeographicRangeImport

    String voiceGeographicRangeImport(int operatorId, String importData, boolean addDestination) throws Exception
    Throws:
      `Exception`

  - ### voiceGeographicRangeSearch

    List<VoiceGeographicRange> voiceGeographicRangeSearch(int operatorId, String txt) throws Exception
    Throws:
      `Exception`

  - ### voiceGeographicRanges

    List<VoiceGeographicRange> voiceGeographicRanges(List<Integer> rangeIds) throws Exception
    Throws:
      `Exception`